#include<iostream>
#include<string>
#include<string.h>
#include<stack>
#include<assert.h>
#include<queue>
#include<algorithm>
#include<sstream>

using namespace std;

class RecentCounter {
public:
    RecentCounter() {}
    
    int ping(int t) {
        //首先把要添加的时间放进来
	pings.push(t);
	while(t - pings.front() > 3000) {
	    pings.pop();
	}

	return pings.size();
    }
public:
    queue<int> pings;
};

/**
 * Your RecentCounter object will be instantiated and called as such:
 * RecentCounter* obj = new RecentCounter();
 * int param_1 = obj->ping(t);
 */

string stringToString(string input) {
    assert(input.length() >= 2);
    string result;
    for (int i = 1; i < input.length() -1; i++) {
        char currentChar = input[i];
        if (input[i] == '\\') {
            char nextChar = input[i+1];
            switch (nextChar) {
                case '\"': result.push_back('\"'); break;
                case '/' : result.push_back('/'); break;
                case '\\': result.push_back('\\'); break;
                case 'b' : result.push_back('\b'); break;
                case 'f' : result.push_back('\f'); break;
                case 'r' : result.push_back('\r'); break;
                case 'n' : result.push_back('\n'); break;
                case 't' : result.push_back('\t'); break;
                default: break;
            }
            i++;
        } else {
          result.push_back(currentChar);
        }
    }
    return result;
}

string boolToString(bool input) {
    return input ? "True" : "False";
}

void trimLeftTrailingQuote(string &input) {
    input.erase(input.begin(), find_if(input.begin(), input.end(), [](int ch) {
        return !(ch == '"');
    }));
}

void trimRightTrailingQuote(string &input) {
    input.erase(find_if(input.rbegin(), input.rend(), [](int ch) {
        return !(ch == '"');
    }).base(), input.end());
}

void trimLeftTrailingSpaces(string &input) {
    input.erase(input.begin(), find_if(input.begin(), input.end(), [](int ch) {
        return !isspace(ch);
    }));
}

void trimRightTrailingSpaces(string &input) {
    input.erase(find_if(input.rbegin(), input.rend(), [](int ch) {
        return !isspace(ch);
    }).base(), input.end());
}

//举例:[1,2,3,null,5,null,4]

vector<string> stringToVector(string input) {
    vector<string> inputVector;

    trimLeftTrailingSpaces(input);
    trimRightTrailingSpaces(input);
    input = input.substr(0, input.length());//去掉[1,2,3,null,5,null,4]中的前面的[和最后的],变为:1,2,3,null,5,null,4;

    string item;
    stringstream ss;
    ss.str(input);

    getline(ss, item, ',');                         
    inputVector.push_back(item);

    while (true) {                               
        if (!getline(ss, item, ',')) {    
            break;
        }
        trimLeftTrailingSpaces(item);
        trimRightTrailingSpaces(item);
	//cout << item << endl;
        inputVector.push_back(item);
    }

    return inputVector;
}

string integerVectorToString(vector<int> list, int length = -1) {
    if (length == -1) {
        length = list.size();
    }

    if (length == 0) {
        return "[]";
    }

    string result;
    for(int index = 0; index < length; index++) {
        int number = list[index];
        result += to_string(number) + ", ";
    }
    return "[" + result.substr(0, result.length() - 2) + "]";
}

/*
 * 链接：https://leetcode-cn.com/problems/number-of-recent-calls
输入：
["RecentCounter", "ping", "ping", "ping", "ping"]
[[], [1], [100], [3001], [3002]]
输出：
[null, 1, 2, 3, 3]
*/

int main() {
    string line;
    int cnt = 0;
    RecentCounter *recentCounter = new RecentCounter();
    
    while (getline(cin, line)) {
        string s = stringToString(line);
        vector<string> pingVector = stringToVector(s);

	cnt++;
	if(cnt%2 == 0) {
            vector<string> outputVector;
	    cout << "processing cnt=" << cnt << endl;
            for(std::vector<string>::iterator it = pingVector.begin(); it != pingVector.end(); it++ ) {
                (*it) = (*it).substr(1, (*it).length() - 2);
		if((*it).length() == 0) {
                    cout << *it << endl;
		    outputVector.push_back("null");
		} else {
		    int ch;
                    //cout << *it << endl;
                    //cout << stoi(*it) << endl;
		    ch = recentCounter->ping(stoi(*it));
		    outputVector.push_back(to_string(ch));
		}
            }
	    cout << "processing end" << cnt << endl;
            string result;
            for(std::vector<string>::iterator it = outputVector.begin(); it != outputVector.end(); it++ ) {
                //cout << *it << endl;
                result += (*it) + ", ";
	    }
            cout << "[" << result.substr(0, result.length() - 2) << "]" << endl;
            //return "[" + result.substr(0, result.length() - 2) + "]";
	}
    }
    return 0;
}
