#include "thread_pool.h"
#include <chrono>
#include <iostream>
#include <string>
#include <boost/format.hpp>

std::mutex g_printMtx;

void test1() {
  for (int i = 0; i < 500; i++) {
    std::this_thread::sleep_for(std::chrono::milliseconds(1));
    auto temp = boost::format("test1\n");
    std::lock_guard<std::mutex> guard(g_printMtx);
    std::cout << temp;
  }
}

void test2(int a, int b) {
  for (int i = 0; i < 500; i++) {
    std::this_thread::sleep_for(std::chrono::milliseconds(1));
    auto c = a + b;
    auto temp = boost::format("test2: %1% + %2% = %3%\n") % a % b % c;
    std::lock_guard<std::mutex> guard(g_printMtx);
    std::cout << temp;
  }
}

void test3() {
  for (int i = 0; i < 500; i++) {
    std::this_thread::sleep_for(std::chrono::milliseconds(1));
    auto temp = boost::format("test3\n");
    std::lock_guard<std::mutex> guard(g_printMtx);
    std::cout << temp;
  }
}

int main()
{
  Add::Threadpool pool;
  pool.Init(10);
  pool.Start();
  pool.PostTask(test1);
  pool.PostTask(std::bind(test2, 3, 5));
  for (int i = 10; i < 40; i++) {
    pool.PostTask(std::bind(test2, i, i * 2));
  }
  pool.PostTask(test3);
  //std::this_thread::sleep_for(std::chrono::nanoseconds(1));
  pool.WaitTasks();
  //pool.CancelTasks();
  //pool.Stop();
  return 0;
}

